AppTitle "TANK COMBAT by Mr.Keks"

;Developed by Mr.Keks over night
;from 2009/08/08 to 2009/08/09
;during Berlin Blitz Coder Party
;at Chaos Coder's

;PLAYER ONE: WASD and [tab] for firing
;PLAYER TWO: Cursor keys and [ctrl]
;Have fun!

;(Feel free to make changes to the code!
;Especially frame independant movement
;would be nice...)

;Visit www.mrkeks.net

Global Main_Width = 1024
Global Main_Height = 768

Const MAIN_MENU = 0
Const MAIN_FLY	= 1
Const MAIN_GAME = 2
Global Main_GameState = MAIN_GAME

Include "map.bb"
Include "camera.bb"
Include "control.bb"
Include "tank.bb"
Include "shot.bb"
Include "explosion.bb"
Include "gui.bb"
Include "extra.bb"

Graphics3D Main_Width, Main_Height, 32, 2
SetBuffer BackBuffer()

Cam_Init()
Map_GenerateMap(128)

Global Main_Player1.TTank = Tank_CreateTank(1)
Global Main_Player2.TTank = Tank_CreateTank(2)

Main_SetGameState(MAIN_GAME)

Collisions TANK_TYPE, TANK_TYPE, 3,3
Collisions TANK_TYPE, MAP_TYPE, 2,3
Collisions SHOT_TYPE, MAP_TYPE, 2,1
Collisions SHOT_TYPE, TANK_Type, 3,1

Repeat
	UpdateWorld
	RenderWorld
	
	Control_Update()
	Cam_Update()
	Tank_Update()
	Shot_Update()
	Exp_Update()
	Map_Update()
	Extra_Update()
	
	Color 0,0,0
	Rect Main_Width/2-3,0,6,Main_Height
	
	Flip
Until KeyHit(1)
End

Function Main_SetGameState(state)
	Select Main_GameState
	Case MAIN_MENU
	Case MAIN_FLY
		HideEntity Cam_Cam
	Case MAIN_GAME
		Tank_HidePlayerCams()
	End Select
	
	Main_GameState = state
	Select Main_GameState
	Case MAIN_MENU
	Case MAIN_FLY
		ShowEntity Cam_Cam
		Control_State = CONTROL_FLY
	Case MAIN_GAME
		Control_State = CONTROL_PLAY
		Tank_ShowPlayerCams()
	End Select
End Function